from setuptools import setup


def readme():
    with open('README.rst') as f:
        return f.read()


setup(name='opsutils',
      version='0.2.9',
      description='that thing you need',
      long_description=readme(),
      classifiers=[],
      keywords='aws docker hover cloud',
      url='https://github.com/minskmaz/opsutils',
      author='Nona Yerbiz',
      author_email='jonah.crawford@protonmail.com',
      license='LICENSE.txt',
      packages=['opsutils'],
      install_requires=[
        'awscli==1.10.62',
        'botocore==1.4.52',
        'BTrees==4.3.1',
        'colorama==0.3.7',
        'docker-py==1.9.0',
        'docutils==0.12',
        'ecdsa==0.13',
        'Fabric==1.12.0',
        'futures==3.0.5',
        'jmespath==0.9.0',
        'paramiko==1.17.2',
        'persistent==4.2.1',
        'psutil==4.3.1',
        'pyasn1==0.1.9',
        'pycrypto==2.6.1',
        'python-dateutil==2.5.3',
        'pytz==2016.6.1',
        'requests==2.11.1',
        'rsa==3.4.2',
        's3transfer==0.1.3',
        'simple-crypt==4.1.7',
        'six==1.10.0',
        'transaction==1.6.1',
        'zope.annotation==4.4.1',
        'zope.browser==2.1.0',
        'zope.component==4.3.0',
        'zope.configuration==4.0.3',
        'zope.container==4.1.0',
        'zope.contenttype==4.2.0',
        'zope.dottedname==4.1.0',
        'zope.event==4.2.0',
        'zope.exceptions==4.0.8',
        'zope.filerepresentation==4.1.0',
        'zope.i18n==4.1.0',
        'zope.i18nmessageid==4.0.3',
        'zope.interface==4.3.2',
        'zope.lifecycleevent==4.1.0',
        'zope.location==4.0.3',
        'zope.proxy==4.2.0',
        'zope.publisher==4.3.0',
        'zope.schema==4.4.2',
        'zope.security==4.0.3',
        'zope.site==4.0.0',
        'zope.size==4.1.0',
        'zope.traversing==4.1.0'
      ],
      test_suite='nose.collector',
      tests_require=['nose', 'nose-cover3'],
      entry_points={
          'console_scripts': ['funniest-joke=funniest.command_line:main'],
      },
      include_package_data=True,
      zip_safe=False)
